import { CodeProject } from "./project";
import { FileData } from "../common/workertypes";
import { ProjectWindows } from "./windows";
import { Platform, EmuState } from "../common/baseplatform";
import { EmuHalt } from "../common/emu";
export declare var platform_id: string;
export declare var store_id: string;
export declare var repo_id: string;
export declare var platform: Platform;
export declare var current_project: CodeProject;
export declare var projectWindows: ProjectWindows;
export declare var compparams: any;
export declare var lastDebugState: EmuState;
export declare function loadScript(scriptfn: string): Promise<Event>;
export declare function runToPC(pc: number): void;
export declare function setFrameRateUI(fps: number): void;
export declare var qs: {};
export declare function haltEmulation(err?: EmuHalt): void;
export declare function setupSplits(): void;
export declare function startUI(): Promise<void>;
export declare function setTestInput(path: string, data: FileData): void;
export declare function getTestOutput(path: string): FileData;
export declare function getSaveState(): EmuState;
export declare function emulationHalted(err: EmuHalt): void;
export declare function getElectronFile(url: string, success: (text: string | Uint8Array) => void, datatype: 'text' | 'arraybuffer'): void;
export declare function reloadWorkspaceFile(path: string): void;
export declare function highlightSearch(query: string): void;
