"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var emu_1 = require("../common/emu");
var ScriptPlatform = /** @class */ (function () {
    function ScriptPlatform(mainElement) {
        this.mainElement = mainElement;
        this.iframe = $('<iframe sandbox="allow-same-origin allow-scripts" width="100%" height="100%"/>').appendTo(mainElement)[0];
        this.iframe.style.backgroundColor = 'white';
        mainElement.classList.add("vertical-scroll"); //100% height
        mainElement.style.overflowY = 'auto';
    }
    ScriptPlatform.prototype.start = function () {
    };
    ScriptPlatform.prototype.reset = function () {
    };
    ScriptPlatform.prototype.pause = function () {
    };
    ScriptPlatform.prototype.resume = function () {
    };
    ScriptPlatform.prototype.loadROM = function (title, data) {
        var contents = $(this.iframe).contents();
        var script = $("<script/>").html(data);
        contents.find('body').empty().append(script);
    };
    ScriptPlatform.prototype.isRunning = function () {
        return false;
    };
    ScriptPlatform.prototype.isDebugging = function () {
        return false;
    };
    ScriptPlatform.prototype.getToolForFilename = function (fn) {
        return "javascript";
    };
    ScriptPlatform.prototype.getDefaultExtension = function () {
        return ".js";
    };
    ScriptPlatform.prototype.getPresets = function () {
        return [
            { id: 'hello.js', name: 'Hello' },
        ];
    };
    return ScriptPlatform;
}());
emu_1.PLATFORMS['script'] = ScriptPlatform;
//# sourceMappingURL=script.js.map